/* Copyright (C) 2001  Sony Computer Entertainment Inc.
 *
 * "draw.vcl"
 *
 */
.include	"vumacros.m"

kScreenMat0             .assign         512
kScreenMat1             .assign         513
kScreenMat2             .assign         514
kScreenMat3             .assign         515
kLocalWorld0            .assign         504
kLocalWorld1            .assign         505
kLocalWorld2            .assign         506
kLocalWorld3            .assign         507
kLightColor0            .assign         496
kLightColor1            .assign         497
kLightColor2            .assign         498
kLightColor3            .assign         499
kLightMatrix0           .assign         500
kLightMatrix1           .assign         501
kLightMatrix2           .assign         502
kLightMatrix3           .assign         503
kColorMaxMin            .assign         525

;kTransform0		.assign		520
;kTransform1		.assign		521
;kTransform2		.assign		522
;kTransform3		.assign		523

        .init_vf_all    ; allow vcl to use all VF registers
        .init_vi_all    ; allow vcl to use all VI registers
        .syntax new
 
        .vu
 
        --enter         ; declare an entry point to the code
                        ; there are no externally set registers..
        --endenter      ; end declaration of entry point

        lq ScreenMat[0], kScreenMat0(vi00);
        lq ScreenMat[1], kScreenMat1(vi00)
        lq ScreenMat[2], kScreenMat2(vi00)
        lq ScreenMat[3], kScreenMat3(vi00)
        lq LocalWorld[0], kLocalWorld0(vi00);
        lq LocalWorld[1], kLocalWorld1(vi00)
        lq LocalWorld[2], kLocalWorld2(vi00)
        lq LocalWorld[3], kLocalWorld3(vi00)
 
        mat_x_mat Transform, LocalWorld, ScreenMat      ; mat_x_mat nm,lm,rm   nm = lm x
rm
 
        lq LightColor[0], kLightColor0(vi00);
        lq LightColor[1], kLightColor1(vi00)
        lq LightColor[2], kLightColor2(vi00)
        lq LightColor[3], kLightColor3(vi00)
        lq LightMatrix[0], kLightMatrix0(vi00)
        lq LightMatrix[1], kLightMatrix1(vi00)
        lq LightMatrix[2], kLightMatrix2(vi00)
        lq LightMatrix[3], kLightMatrix3(vi00)

	lq ColorMaxMin, kColorMaxMin(vi00) ; load COLOR MAX/MIN

	--cont

START1: 
	 xtop iVert_in 		; load TOP reg (actually "0") 
	 iadd iBase, vi00, iVert_in  ; copy it to iBase
	 ilwr.x iVertCount, (iVert_in)x   ; Load GIF Packet value(to get nb of vertices).
	 iaddiu iMask, vi00, 0x7fff; mask nb of "NLOOP" in GIF packet
	 iand iVertCount, iMask, iVertCount ; mask it. we have nb triangles
	 iadd iMask, iVertCount, iVertCount
	 iadd iVertCount, iMask, iVertCount ; just doing "x3" ;-). total of vertices
	 iaddiu iNormal, iVert_in, 61 ; sets the pointer for normal.
	 iaddiu iCol_in, iVert_in, 121 ; sets the pointer for rgba
	 iaddiu iST_in, iVert_in, 122 ; sets the pointer for st
	 iaddiu iKick, iVert_in, 183 ; pointer for XGKICK 
	 iaddiu iXYZF2_out, iVert_in, 186 ; pointer for XYZF2
	 iaddiu iRGBAQ_out, iVert_in, 185 ; pointer for RGBAQ
	 iaddiu iST_out, iVert_in, 184 ; pointer for ST
	 iaddiu iVert_in, iVert_in, 1   ; sets the pointer for vertices.

START: 
	 lq RGB_in, 0(iCol_in) 	;doesn't change
LOOP1: 
	--LoopCS 3,3
	; Just copy ST
	 lqi ST, (iST_in++)
	 sq ST, 0(iST_out)
	 iaddiu iST_out, iST_out, 3

	 lqi Normal, (iNormal++) 
	; Light Matrix x Normal - > light rgb intensity (Col)
	 vec_x_matX	Col, Normal, LightMatrix

	 max Col, Col, vf00[x]	; only want +ve numbers

	 ; Apply the light color
	 vec_x_mat floatScreenCol, Col, LightColor
	 mul floatScreenCol, floatScreenCol, RGB_in
	 mini floatScreenCol, floatScreenCol, ColorMaxMin
	 ftoi0 RGBAQval, floatScreenCol
	 sq RGBAQval, 0(iRGBAQ_out)
	 iaddiu iRGBAQ_out, iRGBAQ_out, 3

	 lqi Vert, (iVert_in++) 
	 ; Transform vert
	 vec_x_mat trans_vert, Vert, Transform

	 div q, vf00[w], trans_vert[w]
	 mulq floatScreenVert, trans_vert, q
	 ftoi4 XYZF2val, floatScreenVert 	   
	 sq XYZF2val, 0(iXYZF2_out) 
	 iaddiu iXYZF2_out, iXYZF2_out, 3

	 iaddi iVertCount, iVertCount, -1

	 ibne iVertCount, vi00, LOOP1

	 lq GifTag, 0(iBase) 	;GIFTAG
	 sq GifTag, 0(iKick) 
	--barrier
	 xgkick iKick  

	 --cont

	 b START1

.END
