/* Copyright (C) 2001  Sony Computer Entertainment Inc.
 *
 * "p.vcl"
 *
 */
.include        "vumacros.m"     

; -------------------------------------
;
;          particle calc micro
;
; -------------------------------------
kPerspMat		.assign         0
kOffsetVecs		.assign         4
kSTVecs			.assign         8
kGifTag			.assign         12

kNumMBlur		.assign		10

        .init_vf_all    ; allow vcl to use all VF registers
        .init_vi_all    ; allow vcl to use all VI registers
        .syntax new
 
        .vu
 
        --enter         ; declare an entry point to the code
                        ; there are no externally set registers..
        --endenter      ; end declaration of entry point

        lq PerspMat[0], kPerspMat(vi00);
        lq PerspMat[1], kPerspMat+1(vi00)
        lq PerspMat[2], kPerspMat+2(vi00)
        lq PerspMat[3], kPerspMat+3(vi00)

        lq OffsetVecs[0], kOffsetVecs(vi00);
        ;lq OffsetVecs[1], kOffsetVecs+1(vi00) never used
        ;lq OffsetVecs[2], kOffsetVecs+2(vi00) never used
        lq OffsetVecs[3], kOffsetVecs+3(vi00)

        lq STVecs[0], kSTVecs(vi00);
        lq STVecs[1], kSTVecs+1(vi00)
        lq STVecs[2], kSTVecs+2(vi00)
        lq STVecs[3], kSTVecs+3(vi00)

	; --- load gif tag ---
	lq GifTag, kGifTag(vi00)

START0:
	xtop iBase
	loi -1.0
	iaddiu iCntN, vi00, 4  ; This is counter.
	iadd iOffsetTmp, iCntN, iCntN    
	iadd iOffsetTmp, iOffsetTmp, iCntN  ; set offset from data area(nb x 3)
	iaddiu Pos_Col, iBase, 1   ; position & color
	iadd iKick, Pos_Col, iOffsetTmp ; xgkick
	iaddiu iRGBAQ_out, iKick, 1 ; RGBAq
	iaddiu iST_out, iKick, 2 ; ST
	iaddiu iXYZF_out, iKick, 3 ; XYZF2
	;-----------------------------------------------
LOOPA:
	iaddiu iMBlurCnt, vi00, kNumMBlur ; nb of motion blur 
	lqi vPos, (Pos_Col++) ; load position
	lqi vVel, (Pos_Col++) ; load velocity
	lqi RGBAval, (Pos_Col++) ; load RGBA
LOOP:
	--LoopCS 10,10
	sq RGBAval, 0(iRGBAQ_out)  ; store RGBA0
	iaddiu iRGBAQ_out, iRGBAQ_out, 9 ; 

	sq STVecs[0], 0(iST_out) ;
	sq STVecs[1], 2(iST_out) ; 
	sq STVecs[2], 4(iST_out)
	sq STVecs[3], 6(iST_out) ;
	iaddiu iST_out, iST_out, 9 ;

	sub vPos, vPos, vVel		

	add vVert, OffsetVecs[0], vPos		
	vec_x_mat vTopLeft, vVert, PerspMat
	div q, vf00[w], vTopLeft[w]	
	mulq vTopLeft, vTopLeft, q		

	add vVert, OffsetVecs[3], vPos		
	vec_x_mat vBottomRight, vVert, PerspMat
	div q, vf00[w], vBottomRight[w]	
	mulq vBottomRight, vBottomRight, q		

	;-------------------------------------------------------
	sub.xy DiffXY, vBottomRight, vTopLeft		

	add vTopRight, vTopLeft, vf00[x]		
	add vBottomLeft, vTopLeft, vf00[x]		

	add.x vTopRight, vTopRight, DiffXY[x]	
	add.y vBottomLeft, vBottomLeft, DiffXY[y] 	
	muli.w vTopLeft, vTopLeft, I		
	muli.w vTopRight, vTopRight, I		

	ftoi4 XYZF0, vTopLeft		
	ftoi4 XYZF1, vTopRight		
	ftoi4 XYZF2, vBottomLeft		
	ftoi4 XYZF3, vBottomRight		

	sq XYZF0, 0(iXYZF_out)  ; store XYZF0 	
	iaddiu iXYZF_out, iXYZF_out, 2 ;
	sq XYZF1, 0(iXYZF_out)  ; store XYZF1
	iaddiu iXYZF_out, iXYZF_out, 2 ;
	sq XYZF2, 0(iXYZF_out)
	iaddiu iXYZF_out, iXYZF_out, 2 
	sq XYZF3, 0(iXYZF_out)
	iaddiu iXYZF_out, iXYZF_out, 3  
	iaddi iMBlurCnt, iMBlurCnt, -1
	ibne iMBlurCnt, vi00, LOOP

	;--------------------------------------------------------
	iaddi iCntN, iCntN, -1
	ibne iCntN, vi00, LOOPA
	;--------------------------------------------------------
	sq GifTag, 0(iKick);
	
	--barrier
	xgkick iKick

	--cont

	;NOP[E]	NOP
	b START0
.END









